// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from sim_arm_location_msg:srv/ChooseCube.idl
// generated code does not contain a copyright notice

#ifndef SIM_ARM_LOCATION_MSG__SRV__DETAIL__CHOOSE_CUBE__FUNCTIONS_H_
#define SIM_ARM_LOCATION_MSG__SRV__DETAIL__CHOOSE_CUBE__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "sim_arm_location_msg/msg/rosidl_generator_c__visibility_control.h"

#include "sim_arm_location_msg/srv/detail/choose_cube__struct.h"

/// Initialize srv/ChooseCube message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * sim_arm_location_msg__srv__ChooseCube_Request
 * )) before or use
 * sim_arm_location_msg__srv__ChooseCube_Request__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_sim_arm_location_msg
bool
sim_arm_location_msg__srv__ChooseCube_Request__init(sim_arm_location_msg__srv__ChooseCube_Request * msg);

/// Finalize srv/ChooseCube message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_sim_arm_location_msg
void
sim_arm_location_msg__srv__ChooseCube_Request__fini(sim_arm_location_msg__srv__ChooseCube_Request * msg);

/// Create srv/ChooseCube message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * sim_arm_location_msg__srv__ChooseCube_Request__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_sim_arm_location_msg
sim_arm_location_msg__srv__ChooseCube_Request *
sim_arm_location_msg__srv__ChooseCube_Request__create();

/// Destroy srv/ChooseCube message.
/**
 * It calls
 * sim_arm_location_msg__srv__ChooseCube_Request__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_sim_arm_location_msg
void
sim_arm_location_msg__srv__ChooseCube_Request__destroy(sim_arm_location_msg__srv__ChooseCube_Request * msg);

/// Check for srv/ChooseCube message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_sim_arm_location_msg
bool
sim_arm_location_msg__srv__ChooseCube_Request__are_equal(const sim_arm_location_msg__srv__ChooseCube_Request * lhs, const sim_arm_location_msg__srv__ChooseCube_Request * rhs);

/// Copy a srv/ChooseCube message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_sim_arm_location_msg
bool
sim_arm_location_msg__srv__ChooseCube_Request__copy(
  const sim_arm_location_msg__srv__ChooseCube_Request * input,
  sim_arm_location_msg__srv__ChooseCube_Request * output);

/// Initialize array of srv/ChooseCube messages.
/**
 * It allocates the memory for the number of elements and calls
 * sim_arm_location_msg__srv__ChooseCube_Request__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_sim_arm_location_msg
bool
sim_arm_location_msg__srv__ChooseCube_Request__Sequence__init(sim_arm_location_msg__srv__ChooseCube_Request__Sequence * array, size_t size);

/// Finalize array of srv/ChooseCube messages.
/**
 * It calls
 * sim_arm_location_msg__srv__ChooseCube_Request__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_sim_arm_location_msg
void
sim_arm_location_msg__srv__ChooseCube_Request__Sequence__fini(sim_arm_location_msg__srv__ChooseCube_Request__Sequence * array);

/// Create array of srv/ChooseCube messages.
/**
 * It allocates the memory for the array and calls
 * sim_arm_location_msg__srv__ChooseCube_Request__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_sim_arm_location_msg
sim_arm_location_msg__srv__ChooseCube_Request__Sequence *
sim_arm_location_msg__srv__ChooseCube_Request__Sequence__create(size_t size);

/// Destroy array of srv/ChooseCube messages.
/**
 * It calls
 * sim_arm_location_msg__srv__ChooseCube_Request__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_sim_arm_location_msg
void
sim_arm_location_msg__srv__ChooseCube_Request__Sequence__destroy(sim_arm_location_msg__srv__ChooseCube_Request__Sequence * array);

/// Check for srv/ChooseCube message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_sim_arm_location_msg
bool
sim_arm_location_msg__srv__ChooseCube_Request__Sequence__are_equal(const sim_arm_location_msg__srv__ChooseCube_Request__Sequence * lhs, const sim_arm_location_msg__srv__ChooseCube_Request__Sequence * rhs);

/// Copy an array of srv/ChooseCube messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_sim_arm_location_msg
bool
sim_arm_location_msg__srv__ChooseCube_Request__Sequence__copy(
  const sim_arm_location_msg__srv__ChooseCube_Request__Sequence * input,
  sim_arm_location_msg__srv__ChooseCube_Request__Sequence * output);

/// Initialize srv/ChooseCube message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * sim_arm_location_msg__srv__ChooseCube_Response
 * )) before or use
 * sim_arm_location_msg__srv__ChooseCube_Response__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_sim_arm_location_msg
bool
sim_arm_location_msg__srv__ChooseCube_Response__init(sim_arm_location_msg__srv__ChooseCube_Response * msg);

/// Finalize srv/ChooseCube message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_sim_arm_location_msg
void
sim_arm_location_msg__srv__ChooseCube_Response__fini(sim_arm_location_msg__srv__ChooseCube_Response * msg);

/// Create srv/ChooseCube message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * sim_arm_location_msg__srv__ChooseCube_Response__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_sim_arm_location_msg
sim_arm_location_msg__srv__ChooseCube_Response *
sim_arm_location_msg__srv__ChooseCube_Response__create();

/// Destroy srv/ChooseCube message.
/**
 * It calls
 * sim_arm_location_msg__srv__ChooseCube_Response__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_sim_arm_location_msg
void
sim_arm_location_msg__srv__ChooseCube_Response__destroy(sim_arm_location_msg__srv__ChooseCube_Response * msg);

/// Check for srv/ChooseCube message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_sim_arm_location_msg
bool
sim_arm_location_msg__srv__ChooseCube_Response__are_equal(const sim_arm_location_msg__srv__ChooseCube_Response * lhs, const sim_arm_location_msg__srv__ChooseCube_Response * rhs);

/// Copy a srv/ChooseCube message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_sim_arm_location_msg
bool
sim_arm_location_msg__srv__ChooseCube_Response__copy(
  const sim_arm_location_msg__srv__ChooseCube_Response * input,
  sim_arm_location_msg__srv__ChooseCube_Response * output);

/// Initialize array of srv/ChooseCube messages.
/**
 * It allocates the memory for the number of elements and calls
 * sim_arm_location_msg__srv__ChooseCube_Response__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_sim_arm_location_msg
bool
sim_arm_location_msg__srv__ChooseCube_Response__Sequence__init(sim_arm_location_msg__srv__ChooseCube_Response__Sequence * array, size_t size);

/// Finalize array of srv/ChooseCube messages.
/**
 * It calls
 * sim_arm_location_msg__srv__ChooseCube_Response__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_sim_arm_location_msg
void
sim_arm_location_msg__srv__ChooseCube_Response__Sequence__fini(sim_arm_location_msg__srv__ChooseCube_Response__Sequence * array);

/// Create array of srv/ChooseCube messages.
/**
 * It allocates the memory for the array and calls
 * sim_arm_location_msg__srv__ChooseCube_Response__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_sim_arm_location_msg
sim_arm_location_msg__srv__ChooseCube_Response__Sequence *
sim_arm_location_msg__srv__ChooseCube_Response__Sequence__create(size_t size);

/// Destroy array of srv/ChooseCube messages.
/**
 * It calls
 * sim_arm_location_msg__srv__ChooseCube_Response__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_sim_arm_location_msg
void
sim_arm_location_msg__srv__ChooseCube_Response__Sequence__destroy(sim_arm_location_msg__srv__ChooseCube_Response__Sequence * array);

/// Check for srv/ChooseCube message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_sim_arm_location_msg
bool
sim_arm_location_msg__srv__ChooseCube_Response__Sequence__are_equal(const sim_arm_location_msg__srv__ChooseCube_Response__Sequence * lhs, const sim_arm_location_msg__srv__ChooseCube_Response__Sequence * rhs);

/// Copy an array of srv/ChooseCube messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_sim_arm_location_msg
bool
sim_arm_location_msg__srv__ChooseCube_Response__Sequence__copy(
  const sim_arm_location_msg__srv__ChooseCube_Response__Sequence * input,
  sim_arm_location_msg__srv__ChooseCube_Response__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // SIM_ARM_LOCATION_MSG__SRV__DETAIL__CHOOSE_CUBE__FUNCTIONS_H_
