// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from sim_arm_location_msg:srv/ChooseCube.idl
// generated code does not contain a copyright notice

#ifndef SIM_ARM_LOCATION_MSG__SRV__DETAIL__CHOOSE_CUBE__TRAITS_HPP_
#define SIM_ARM_LOCATION_MSG__SRV__DETAIL__CHOOSE_CUBE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "sim_arm_location_msg/srv/detail/choose_cube__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace sim_arm_location_msg
{

namespace srv
{

inline void to_flow_style_yaml(
  const ChooseCube_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: num
  {
    out << "num: ";
    rosidl_generator_traits::value_to_yaml(msg.num, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ChooseCube_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: num
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "num: ";
    rosidl_generator_traits::value_to_yaml(msg.num, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ChooseCube_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace sim_arm_location_msg

namespace rosidl_generator_traits
{

[[deprecated("use sim_arm_location_msg::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const sim_arm_location_msg::srv::ChooseCube_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  sim_arm_location_msg::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use sim_arm_location_msg::srv::to_yaml() instead")]]
inline std::string to_yaml(const sim_arm_location_msg::srv::ChooseCube_Request & msg)
{
  return sim_arm_location_msg::srv::to_yaml(msg);
}

template<>
inline const char * data_type<sim_arm_location_msg::srv::ChooseCube_Request>()
{
  return "sim_arm_location_msg::srv::ChooseCube_Request";
}

template<>
inline const char * name<sim_arm_location_msg::srv::ChooseCube_Request>()
{
  return "sim_arm_location_msg/srv/ChooseCube_Request";
}

template<>
struct has_fixed_size<sim_arm_location_msg::srv::ChooseCube_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<sim_arm_location_msg::srv::ChooseCube_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<sim_arm_location_msg::srv::ChooseCube_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace sim_arm_location_msg
{

namespace srv
{

inline void to_flow_style_yaml(
  const ChooseCube_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ChooseCube_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ChooseCube_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace sim_arm_location_msg

namespace rosidl_generator_traits
{

[[deprecated("use sim_arm_location_msg::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const sim_arm_location_msg::srv::ChooseCube_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  sim_arm_location_msg::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use sim_arm_location_msg::srv::to_yaml() instead")]]
inline std::string to_yaml(const sim_arm_location_msg::srv::ChooseCube_Response & msg)
{
  return sim_arm_location_msg::srv::to_yaml(msg);
}

template<>
inline const char * data_type<sim_arm_location_msg::srv::ChooseCube_Response>()
{
  return "sim_arm_location_msg::srv::ChooseCube_Response";
}

template<>
inline const char * name<sim_arm_location_msg::srv::ChooseCube_Response>()
{
  return "sim_arm_location_msg/srv/ChooseCube_Response";
}

template<>
struct has_fixed_size<sim_arm_location_msg::srv::ChooseCube_Response>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<sim_arm_location_msg::srv::ChooseCube_Response>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<sim_arm_location_msg::srv::ChooseCube_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<sim_arm_location_msg::srv::ChooseCube>()
{
  return "sim_arm_location_msg::srv::ChooseCube";
}

template<>
inline const char * name<sim_arm_location_msg::srv::ChooseCube>()
{
  return "sim_arm_location_msg/srv/ChooseCube";
}

template<>
struct has_fixed_size<sim_arm_location_msg::srv::ChooseCube>
  : std::integral_constant<
    bool,
    has_fixed_size<sim_arm_location_msg::srv::ChooseCube_Request>::value &&
    has_fixed_size<sim_arm_location_msg::srv::ChooseCube_Response>::value
  >
{
};

template<>
struct has_bounded_size<sim_arm_location_msg::srv::ChooseCube>
  : std::integral_constant<
    bool,
    has_bounded_size<sim_arm_location_msg::srv::ChooseCube_Request>::value &&
    has_bounded_size<sim_arm_location_msg::srv::ChooseCube_Response>::value
  >
{
};

template<>
struct is_service<sim_arm_location_msg::srv::ChooseCube>
  : std::true_type
{
};

template<>
struct is_service_request<sim_arm_location_msg::srv::ChooseCube_Request>
  : std::true_type
{
};

template<>
struct is_service_response<sim_arm_location_msg::srv::ChooseCube_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // SIM_ARM_LOCATION_MSG__SRV__DETAIL__CHOOSE_CUBE__TRAITS_HPP_
