// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from sim_arm_location_msg:srv/TargetLocation.idl
// generated code does not contain a copyright notice

#ifndef SIM_ARM_LOCATION_MSG__SRV__DETAIL__TARGET_LOCATION__STRUCT_HPP_
#define SIM_ARM_LOCATION_MSG__SRV__DETAIL__TARGET_LOCATION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__sim_arm_location_msg__srv__TargetLocation_Request __attribute__((deprecated))
#else
# define DEPRECATED__sim_arm_location_msg__srv__TargetLocation_Request __declspec(deprecated)
#endif

namespace sim_arm_location_msg
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct TargetLocation_Request_
{
  using Type = TargetLocation_Request_<ContainerAllocator>;

  explicit TargetLocation_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->x = 0.0f;
      this->y = 0.0f;
      this->z = 0.0f;
    }
  }

  explicit TargetLocation_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->x = 0.0f;
      this->y = 0.0f;
      this->z = 0.0f;
    }
  }

  // field types and members
  using _x_type =
    float;
  _x_type x;
  using _y_type =
    float;
  _y_type y;
  using _z_type =
    float;
  _z_type z;

  // setters for named parameter idiom
  Type & set__x(
    const float & _arg)
  {
    this->x = _arg;
    return *this;
  }
  Type & set__y(
    const float & _arg)
  {
    this->y = _arg;
    return *this;
  }
  Type & set__z(
    const float & _arg)
  {
    this->z = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    sim_arm_location_msg::srv::TargetLocation_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const sim_arm_location_msg::srv::TargetLocation_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<sim_arm_location_msg::srv::TargetLocation_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<sim_arm_location_msg::srv::TargetLocation_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      sim_arm_location_msg::srv::TargetLocation_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<sim_arm_location_msg::srv::TargetLocation_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      sim_arm_location_msg::srv::TargetLocation_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<sim_arm_location_msg::srv::TargetLocation_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<sim_arm_location_msg::srv::TargetLocation_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<sim_arm_location_msg::srv::TargetLocation_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__sim_arm_location_msg__srv__TargetLocation_Request
    std::shared_ptr<sim_arm_location_msg::srv::TargetLocation_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__sim_arm_location_msg__srv__TargetLocation_Request
    std::shared_ptr<sim_arm_location_msg::srv::TargetLocation_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TargetLocation_Request_ & other) const
  {
    if (this->x != other.x) {
      return false;
    }
    if (this->y != other.y) {
      return false;
    }
    if (this->z != other.z) {
      return false;
    }
    return true;
  }
  bool operator!=(const TargetLocation_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TargetLocation_Request_

// alias to use template instance with default allocator
using TargetLocation_Request =
  sim_arm_location_msg::srv::TargetLocation_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace sim_arm_location_msg


#ifndef _WIN32
# define DEPRECATED__sim_arm_location_msg__srv__TargetLocation_Response __attribute__((deprecated))
#else
# define DEPRECATED__sim_arm_location_msg__srv__TargetLocation_Response __declspec(deprecated)
#endif

namespace sim_arm_location_msg
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct TargetLocation_Response_
{
  using Type = TargetLocation_Response_<ContainerAllocator>;

  explicit TargetLocation_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  explicit TargetLocation_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    sim_arm_location_msg::srv::TargetLocation_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const sim_arm_location_msg::srv::TargetLocation_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<sim_arm_location_msg::srv::TargetLocation_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<sim_arm_location_msg::srv::TargetLocation_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      sim_arm_location_msg::srv::TargetLocation_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<sim_arm_location_msg::srv::TargetLocation_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      sim_arm_location_msg::srv::TargetLocation_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<sim_arm_location_msg::srv::TargetLocation_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<sim_arm_location_msg::srv::TargetLocation_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<sim_arm_location_msg::srv::TargetLocation_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__sim_arm_location_msg__srv__TargetLocation_Response
    std::shared_ptr<sim_arm_location_msg::srv::TargetLocation_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__sim_arm_location_msg__srv__TargetLocation_Response
    std::shared_ptr<sim_arm_location_msg::srv::TargetLocation_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TargetLocation_Response_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    return true;
  }
  bool operator!=(const TargetLocation_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TargetLocation_Response_

// alias to use template instance with default allocator
using TargetLocation_Response =
  sim_arm_location_msg::srv::TargetLocation_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace sim_arm_location_msg

namespace sim_arm_location_msg
{

namespace srv
{

struct TargetLocation
{
  using Request = sim_arm_location_msg::srv::TargetLocation_Request;
  using Response = sim_arm_location_msg::srv::TargetLocation_Response;
};

}  // namespace srv

}  // namespace sim_arm_location_msg

#endif  // SIM_ARM_LOCATION_MSG__SRV__DETAIL__TARGET_LOCATION__STRUCT_HPP_
